Attribute VB_Name = "Modul1"
Option Explicit

Type WAVEFILEHEADER
  RIFF As Long
  FLength As Long
  WAVE As Long
  FMT As Long
  L16 As Long
  PCM1 As Integer
  nChannels As Integer
  nSamplesPerSec As Long
  nAvgBytesPerSec As Long
  nBlockAlign As Integer
  wBitsPerSample As Integer
  DATA As Long
  DLength As Long
End Type

Type WAVEFORMATEX
  wFormatTag As Integer
  nChannels As Integer
  nSamplesPerSec As Long
  nAvgBytesPerSec As Long
  nBlockAlign As Integer
  wBitsPerSample As Integer
  cbSize As Integer
End Type

Type WAVEFORMAT
  wFormatTag As Integer
  nChannels As Integer
  nSamplesPerSec As Long
  nAvgBytesPerSec As Long
  nBlockAlign As Integer
End Type

Type WAVEHDR
  lpData As Long
  dwBufferLength As Long
  dwBytesRecorded As Long
  dwUser As Long
  dwFlags As Long
  dwLoops As Long
  lpNext As Long
  Reserved As Long
End Type

Type WAVEINCAPS
  wMid As Integer
  wPid As Integer
  vDriverVersion As Long
  szPname As String * 32
  dwFormats As Long
  wChannels As Integer
End Type

Type WAVEOUTCAPS
  wMid As Integer
  wPid As Integer
  vDriverVersion As Long
  szPname As String * 32
  dwFormats As Long
  wChannels As Integer
  dwSupport As Long
End Type

Type MMTIME
  wType As Long
  ms As Long
  smpl As Long
  cb As Long
  ticks As Long
  smpte(0 To 7) As Byte
  midisongptrpos As Long
End Type

Type Stereo
  L As Integer
  R As Integer
End Type

Public Const MMSYSERR_BASE = 0
Public Const MMSYSERR_ALLOCATED = (MMSYSERR_BASE + 4)     '  device already allocated
Public Const MMSYSERR_BADDEVICEID = (MMSYSERR_BASE + 2)   '  device ID out of range
Public Const MMSYSERR_BADERRNUM = (MMSYSERR_BASE + 9)     '  error value out of range
Public Const MMSYSERR_ERROR = (MMSYSERR_BASE + 1)         '  unspecified error
Public Const MMSYSERR_HANDLEBUSY = (MMSYSERR_BASE + 12)   '  handle being used
Public Const MMSYSERR_INVALFLAG = (MMSYSERR_BASE + 10)    '  invalid flag passed
Public Const MMSYSERR_INVALHANDLE = (MMSYSERR_BASE + 5)   '  device handle is invalid
Public Const MMSYSERR_INVALIDALIAS = (MMSYSERR_BASE + 13) '  "Specified alias not found in WIN.INI
Public Const MMSYSERR_INVALPARAM = (MMSYSERR_BASE + 11)   '  invalid parameter passed
Public Const MMSYSERR_LASTERROR = (MMSYSERR_BASE + 13)    '  last error in range
Public Const MMSYSERR_NODRIVER = (MMSYSERR_BASE + 6)      '  no device driver present
Public Const MMSYSERR_NOERROR = 0                         '  no error
Public Const MMSYSERR_NOMEM = (MMSYSERR_BASE + 7)         '  memory allocation error
Public Const MMSYSERR_NOTENABLED = (MMSYSERR_BASE + 3)    '  driver failed enable
Public Const MMSYSERR_NOTSUPPORTED = (MMSYSERR_BASE + 8)  '  function isn't supported
Public Const WAVE_ALLOWSYNC = &H2
Public Const WAVE_FORMAT_1M08 = &H1                       '  11.025 kHz, Mono,   8-bit
Public Const WAVE_FORMAT_1M16 = &H4                       '  11.025 kHz, Mono,   16-bit
Public Const WAVE_FORMAT_1S08 = &H2                       '  11.025 kHz, Stereo, 8-bit
Public Const WAVE_FORMAT_1S16 = &H8                       '  11.025 kHz, Stereo, 16-bit
Public Const WAVE_FORMAT_2M08 = &H10                      '  22.05  kHz, Mono,   8-bit
Public Const WAVE_FORMAT_2M16 = &H40                      '  22.05  kHz, Mono,   16-bit
Public Const WAVE_FORMAT_2S08 = &H20                      '  22.05  kHz, Stereo, 8-bit
Public Const WAVE_FORMAT_2S16 = &H80                      '  22.05  kHz, Stereo, 16-bit
Public Const WAVE_FORMAT_4M08 = &H100                     '  44.1   kHz, Mono,   8-bit
Public Const WAVE_FORMAT_4M16 = &H400                     '  44.1   kHz, Mono,   16-bit
Public Const WAVE_FORMAT_4S08 = &H200                     '  44.1   kHz, Stereo, 8-bit
Public Const WAVE_FORMAT_4S16 = &H800                     '  44.1   kHz, Stereo, 16-bit
Public Const WAVE_FORMAT_DIRECT = &H8
Public Const WAVE_FORMAT_QUERY = &H1
Public Const WAVE_FORMAT_DIRECT_QUERY = (WAVE_FORMAT_QUERY Or WAVE_FORMAT_DIRECT)
Public Const WAVE_FORMAT_PCM = 1                          '  Needed in resource files so outside #ifndef RC_INVOKED
Public Const WAVE_INVALIDFORMAT = &H0                     '  invalid format
Public Const WAVE_MAPPED = &H4
Public Const WAVE_MAPPER = -1&
Public Const WAVE_VALID = &H3                             '  ;Internal
Public Const WAVECAPS_LRVOLUME = &H8                      '  separate left-right volume control
Public Const WAVECAPS_PITCH = &H1                         '  supports pitch control
Public Const WAVECAPS_PLAYBACKRATE = &H2                  '  supports playback rate control
Public Const WAVECAPS_SYNC = &H10
Public Const WAVECAPS_VOLUME = &H4                        '  supports volume control
Public Const WAVERR_BASE = 32
Public Const WAVERR_BADFORMAT = (WAVERR_BASE + 0)         '  unsupported wave format
Public Const WAVERR_LASTERROR = (WAVERR_BASE + 3)         '  last error in range
Public Const WAVERR_STILLPLAYING = (WAVERR_BASE + 1)      '  still something playing
Public Const WAVERR_SYNC = (WAVERR_BASE + 3)              '  device is synchronous
Public Const WAVERR_UNPREPARED = (WAVERR_BASE + 2)        '  header not prepared
Public Const WHDR_BEGINLOOP = &H4                         '  loop start block
Public Const WHDR_DONE = &H1                              '  done bit
Public Const WHDR_ENDLOOP = &H8                           '  loop end block
Public Const WHDR_INQUEUE = &H10                          '  reserved for driver
Public Const WHDR_PREPARED = &H2                          '  set if this header has been prepared
Public Const WHDR_VALID = &H1F                            '  valid flags      / ;Internal /

Declare Function RtlMoveMemory Lib "kernel32" (Dest As Any, Src As Any, ByVal ByteCount As Long) As Long
Declare Function VarPtr Lib "vb40032" (V As Any) As Long
Declare Function waveOutBreakLoop Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
Declare Function waveOutClose Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
Declare Function waveOutGetDevCaps Lib "winmm.dll" Alias "waveOutGetDevCapsA" (ByVal uDeviceID As Long, lpCaps As WAVEOUTCAPS, ByVal uSize As Long) As Long
Declare Function waveOutGetErrorText Lib "winmm.dll" Alias "waveOutGetErrorTextA" (ByVal err As Long, ByVal lpText As String, ByVal uSize As Long) As Long
Declare Function waveOutGetID Lib "winmm.dll" (ByVal hWaveOut As Long, lpuDeviceID As Long) As Long
Declare Function waveOutGetNumDevs Lib "winmm.dll" () As Long
Declare Function waveOutGetPitch Lib "winmm.dll" (ByVal hWaveOut As Long, lpdwPitch As Long) As Long
Declare Function waveOutGetPlaybackRate Lib "winmm.dll" (ByVal hWaveOut As Long, lpdwRate As Long) As Long
Declare Function waveOutGetPosition Lib "winmm.dll" (ByVal hWaveOut As Long, lpInfo As MMTIME, ByVal uSize As Long) As Long
Declare Function waveOutGetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, lpdwVolume As Long) As Long
Declare Function waveOutMessage Lib "winmm.dll" (ByVal hWaveOut As Long, ByVal msg As Long, ByVal dw1 As Long, ByVal dw2 As Long) As Long
Declare Function waveOutOpen Lib "winmm.dll" (lphWaveOut As Long, ByVal uDeviceID As Long, lpFormat As WAVEFORMATEX, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Declare Function waveOutPause Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
Declare Function waveOutPrepareHeader Lib "winmm.dll" (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Declare Function waveOutReset Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
Declare Function waveOutRestart Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
Declare Function waveOutSetPlaybackRate Lib "winmm.dll" (ByVal hWaveOut As Long, ByVal dwRate As Long) As Long
Declare Function waveOutSetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, ByVal dwVolume As Long) As Long
Declare Function waveOutUnprepareHeader Lib "winmm.dll" (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Declare Function waveOutWrite Lib "winmm.dll" (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Declare Function waveInPrepareHeader Lib "winmm.dll" (ByVal hWaveIn As Long, lpWaveInHdr As WAVEHDR, ByVal uSize As Long) As Long

Public Bufs(1 To 2) As WAVEHDR, Sum1() As Stereo, Sum2() As Stereo
Public WaveDev&, LMax&(1 To 2), RMax&(1 To 2), LScale#, RScale#, WaveStop As Boolean

Sub OpenWaveDev(Samp&)
Dim i%, WFormat As WAVEFORMATEX
  'Device-Settings
  With WFormat
    .wFormatTag = WAVE_FORMAT_PCM
    .nChannels = 2
    .wBitsPerSample = 16
    .nSamplesPerSec = Samp
    .nBlockAlign = .nChannels * .wBitsPerSample \ 8
    .nAvgBytesPerSec = .nBlockAlign * .nSamplesPerSec
  End With
  If waveOutOpen(WaveDev, 0, WFormat, 0, 0, 0) <> 0 Then MsgBox "No puedo inicializar el dispositivo de sonido.", vbCritical, "Error"
End Sub

Sub SendBlock(WD() As Stereo, ByVal FBNr%, ByVal BufLength&)
  waveOutUnprepareHeader WaveDev, Bufs(FBNr), 32
  Bufs(FBNr).dwBufferLength = BufLength
  Bufs(FBNr).lpData = VarPtr(WD(1))
  waveOutPrepareHeader WaveDev, Bufs(FBNr), 32
  waveOutWrite WaveDev, Bufs(FBNr), 32
End Sub

Function GetFreeBufNr() As Integer
Dim i
  Do
    DoEvents
    If WaveStop Then Exit Function
    For i = 1 To UBound(Bufs)
      If Bufs(i).dwFlags = 0 Or (Bufs(i).dwFlags And WHDR_DONE) Then Exit For
    Next i
  Loop While i > UBound(Bufs)
  GetFreeBufNr = i
End Function

Sub CloseWaveDev()
Dim i%
  WaveStop = True
  waveOutRestart WaveDev
  waveOutReset WaveDev
  For i = 1 To UBound(Bufs)
    waveOutUnprepareHeader WaveDev, Bufs(i), 32
  Next i
  waveOutClose WaveDev
End Sub

Sub PlaySound(FName$)
Dim Filenr%, WFH As WAVEFILEHEADER
Dim i&, k&, Sig%, FBNr%, Rest%
  On Error Resume Next
  Synth.Command1.Enabled = False
  
  Rest = 4410
  ReDim Sum1(1 To Rest)
  ReDim Sum2(1 To Rest)
  
  Filenr = FreeFile
  Open FName For Binary As #Filenr
  
  Get #Filenr, , WFH
  OpenWaveDev WFH.nSamplesPerSec
  waveOutRestart WaveDev
  waveOutReset WaveDev
  LMax(2) = 0
  RMax(2) = 0
  
  For i = 1 To WFH.DLength \ 17640
    'Gets a free or an already played buffer from the Queue
    '(Queue has 2 buffers and holds sound for max 0.2 sec)
start:
    FBNr = GetFreeBufNr
    If WaveStop Then GoTo exitmark
    LMax(FBNr) = 0
    RMax(FBNr) = 0
    If FBNr = 1 Then
      'Fills the current buffer with the File-Data
      Get #Filenr, , Sum1()
      'Calculates new Volume and Balance and
      'the Max-Values in the current buffer
      For k = 1 To Rest
        Sum1(k).L = Sum1(k).L * LScale
        Sum1(k).R = Sum1(k).R * RScale
        If Sum1(k).L > LMax(1) Then LMax(1) = Sum1(k).L
        If Sum1(k).R > RMax(1) Then RMax(1) = Sum1(k).R
      Next k
      'Send the buffer to the Wave-Device
      SendBlock Sum1, 1, Rest * 4
      'Refreshes the Level-Meter with the
      'Max-Value of the currently played buffer
      SetAudioLevel LMax(2), RMax(2)
    Else
      'Fills the current buffer with the File-Data
      Get #Filenr, , Sum2()
      'Calculates new Volume and Balance and
      'the Max-Values in the current buffer
      For k = 1 To Rest
        Sum2(k).L = Sum2(k).L * LScale
        Sum2(k).R = Sum2(k).R * RScale
        If Sum2(k).L > LMax(2) Then LMax(2) = Sum2(k).L
        If Sum2(k).R > RMax(2) Then RMax(2) = Sum2(k).R
      Next k
      'Send the buffer to the Wave-Device
      SendBlock Sum2, 2, Rest * 4
      'Refreshes the Level-Meter with the
      'Max-Value of the currently played buffer
      SetAudioLevel LMax(1), RMax(1)
    End If
    
    'Play the Rest
    If i = WFH.DLength \ 17640 And WFH.DLength Mod 17640 > 0 Then
      Rest = (WFH.DLength Mod 17640) \ 4
      ReDim Sum1(1 To Rest)
      ReDim Sum2(1 To Rest)
      i = i + 1
      GoTo start
    End If
  Next i
exitmark:
  CloseWaveDev
  WaveStop = False
  Synth.Command1.Enabled = True
  SetAudioLevel 0, 0, True
  Close
End Sub

Sub SetAudioLevel(L&, R&, Optional Down)
Dim LD#, RD#, i%
Static LMax%, RMax%, C%
  If Not IsMissing(Down) Then
    LMax = 0
    RMax = 0
  End If
  If C = 2 Then C = 0 Else C = C + 1
  LD = L / 1600
  RD = R / 1600
  If LD > LMax Then
    LMax = LD
    C = 0
  ElseIf C = 0 Then
    LMax = LMax - 1
  End If
  If LMax < 0 Then LMax = 0
  If RD > RMax Then
    RMax = RD
    C = 0
  ElseIf C = 0 Then
    RMax = RMax - 1
  End If
  If RMax < 0 Then RMax = 0
  With Synth
    For i = 0 To 20
      If i >= LD Then
        .LA(i).FillStyle = 1
      Else
        .LA(i).FillStyle = 0
      End If
      If i >= RD Then
        .LR(i).FillStyle = 1
      Else
        .LR(i).FillStyle = 0
      End If
    Next i
    If LMax > 0 Then .LA(LMax).FillStyle = 0
    If RMax > 0 Then .LR(RMax).FillStyle = 0
  End With
End Sub
